<center><a href="umfpack.c">Actual source code: umfpack.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:22:52+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/* </font>
<a name="line4">  4: </a><font color="#B22222">        Provides an interface to the UMFPACKv4.3 sparse solver</font>
<a name="line5">  5: </a><font color="#B22222">*/</font>

<a name="line7"> 7: </a> #include <A href="../../../../../../src/mat/impls/aij/seq/aij.h.html">src/mat/impls/aij/seq/aij.h</A>

<a name="line10"> 10: </a><font color="#A020F0">#include </font><font color="#666666">"umfpack.h"</font><font color="#A020F0"></font>

<a name="line13"> 13: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line14"> 14: </a>  void         *Symbolic, *Numeric;
<a name="line15"> 15: </a>  double       Info[UMFPACK_INFO], Control[UMFPACK_CONTROL],*W;
<a name="line16"> 16: </a>  int          *Wi,*ai,*aj,*perm_c;
<a name="line17"> 17: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  *av;
<a name="line18"> 18: </a>  <A href="../../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A> flg;
<a name="line19"> 19: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>   PetscMatOdering;

<a name="line21"> 21: </a>  <font color="#B22222">/* A few function pointers for inheritance */</font>
<a name="line22"> 22: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A>,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*);
<a name="line23"> 23: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>);
<a name="line24"> 24: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Mat/MatAssemblyType.html#MatAssemblyType">MatAssemblyType</A>);
<a name="line25"> 25: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatLUFactorSymbolic.html#MatLUFactorSymbolic">MatLUFactorSymbolic</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*);
<a name="line26"> 26: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>);
<a name="line27"> 27: </a>
<a name="line28"> 28: </a>  <font color="#B22222">/* Flag to clean up UMFPACK objects during Destroy */</font>
<a name="line29"> 29: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> CleanUpUMFPACK;
<a name="line30"> 30: </a>} Mat_UMFPACK;

<a name="line32"> 32: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDuplicate_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A>,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;

<a name="line37"> 37: </a><strong><font color="#4169E1"><a name="MatConvert_UMFPACK_SeqAIJ"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_UMFPACK_SeqAIJ(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A> type,<A href="../../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A> reuse,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *newmat)</font></strong>
<a name="line38"> 38: </a>{
<a name="line40"> 40: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>         B=*newmat;
<a name="line41"> 41: </a>  Mat_UMFPACK *lu=(Mat_UMFPACK*)A-&gt;spptr;

<a name="line44"> 44: </a>  <font color="#4169E1">if</font> (reuse == MAT_INITIAL_MATRIX) {
<a name="line45"> 45: </a>    <A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>(A,MAT_COPY_VALUES,&amp;B);
<a name="line46"> 46: </a>  }
<a name="line47"> 47: </a>  <font color="#B22222">/* Reset the original function pointers */</font>
<a name="line48"> 48: </a>  B-&gt;ops-&gt;duplicate        = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>;
<a name="line49"> 49: </a>  B-&gt;ops-&gt;view             = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>;
<a name="line50"> 50: </a>  B-&gt;ops-&gt;assemblyend      = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>;
<a name="line51"> 51: </a>  B-&gt;ops-&gt;lufactorsymbolic = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatLUFactorSymbolic.html#MatLUFactorSymbolic">MatLUFactorSymbolic</A>;
<a name="line52"> 52: </a>  B-&gt;ops-&gt;destroy          = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>;

<a name="line54"> 54: </a>  PetscObjectComposeFunction((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_seqaij_umfpack_C"</font>,<font color="#666666">""</font>,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line55"> 55: </a>  PetscObjectComposeFunction((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_umfpack_seqaij_C"</font>,<font color="#666666">""</font>,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line57"> 57: </a>  PetscObjectChangeTypeName((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<A href="../../../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A>);
<a name="line58"> 58: </a>  *newmat = B;
<a name="line59"> 59: </a>  <font color="#4169E1">return</font>(0);
<a name="line60"> 60: </a>}

<a name="line65"> 65: </a><strong><font color="#4169E1"><a name="MatDestroy_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDestroy_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A)</font></strong>
<a name="line66"> 66: </a>{
<a name="line68"> 68: </a>  Mat_UMFPACK *lu=(Mat_UMFPACK*)A-&gt;spptr;

<a name="line71"> 71: </a>  <font color="#4169E1">if</font> (lu-&gt;CleanUpUMFPACK) {
<a name="line72"> 72: </a>    umfpack_di_free_symbolic(&amp;lu-&gt;Symbolic);
<a name="line73"> 73: </a>    umfpack_di_free_numeric(&amp;lu-&gt;Numeric);
<a name="line74"> 74: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(lu-&gt;Wi);
<a name="line75"> 75: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(lu-&gt;W);
<a name="line76"> 76: </a>    <font color="#4169E1">if</font> (lu-&gt;PetscMatOdering) {
<a name="line77"> 77: </a>      <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(lu-&gt;perm_c);
<a name="line78"> 78: </a>    }
<a name="line79"> 79: </a>  }
<a name="line80"> 80: </a>  MatConvert_UMFPACK_SeqAIJ(A,<A href="../../../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A>,MAT_REUSE_MATRIX,&amp;A);
<a name="line81"> 81: </a>  (*A-&gt;ops-&gt;destroy)(A);
<a name="line82"> 82: </a>  <font color="#4169E1">return</font>(0);
<a name="line83"> 83: </a>}

<a name="line87"> 87: </a><strong><font color="#4169E1"><a name="MatSolve_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSolve_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> b,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x)</font></strong>
<a name="line88"> 88: </a>{
<a name="line89"> 89: </a>  Mat_UMFPACK *lu = (Mat_UMFPACK*)A-&gt;spptr;
<a name="line90"> 90: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *av=lu-&gt;av,*ba,*xa;
<a name="line92"> 92: </a>  int          *ai=lu-&gt;ai,*aj=lu-&gt;aj,status;
<a name="line93"> 93: </a>
<a name="line95"> 95: </a>  <font color="#B22222">/* solve Ax = b by umfpack_di_wsolve */</font>
<a name="line96"> 96: </a>  <font color="#B22222">/* ----------------------------------*/</font>
<a name="line97"> 97: </a>  <A href="../../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(b,&amp;ba);
<a name="line98"> 98: </a>  <A href="../../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;xa);

<a name="line100">100: </a>  status = umfpack_di_wsolve(UMFPACK_At,ai,aj,av,xa,ba,lu-&gt;Numeric,lu-&gt;Control,lu-&gt;Info,lu-&gt;Wi,lu-&gt;W);
<a name="line101">101: </a>  umfpack_di_report_info(lu-&gt;Control, lu-&gt;Info);
<a name="line102">102: </a>  <font color="#4169E1">if</font> (status &lt; 0){
<a name="line103">103: </a>    umfpack_di_report_status(lu-&gt;Control, status);
<a name="line104">104: </a>    <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_LIB,<font color="#666666">"umfpack_di_wsolve failed"</font>);
<a name="line105">105: </a>  }
<a name="line106">106: </a>
<a name="line107">107: </a>  <A href="../../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(b,&amp;ba);
<a name="line108">108: </a>  <A href="../../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;xa);

<a name="line110">110: </a>  <font color="#4169E1">return</font>(0);
<a name="line111">111: </a>}

<a name="line115">115: </a><strong><font color="#4169E1"><a name="MatLUFactorNumeric_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLUFactorNumeric_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *F)</font></strong>
<a name="line116">116: </a>{
<a name="line117">117: </a>  Mat_UMFPACK *lu=(Mat_UMFPACK*)(*F)-&gt;spptr;
<a name="line119">119: </a>  int         *ai=lu-&gt;ai,*aj=lu-&gt;aj,m=A-&gt;rmap.n,status;
<a name="line120">120: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *av=lu-&gt;av;

<a name="line123">123: </a>  <font color="#B22222">/* numeric factorization of A' */</font>
<a name="line124">124: </a>  <font color="#B22222">/* ----------------------------*/</font>
<a name="line125">125: </a>  <font color="#4169E1">if</font> (lu-&gt;flg == SAME_NONZERO_PATTERN &amp;&amp; lu-&gt;Numeric){
<a name="line126">126: </a>      umfpack_di_free_numeric(&amp;lu-&gt;Numeric);
<a name="line127">127: </a>  }
<a name="line128">128: </a>  status = umfpack_di_numeric (ai,aj,av,lu-&gt;Symbolic,&amp;lu-&gt;Numeric,lu-&gt;Control,lu-&gt;Info);
<a name="line129">129: </a>  <font color="#4169E1">if</font> (status &lt; 0) <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_LIB,<font color="#666666">"umfpack_di_numeric failed"</font>);
<a name="line130">130: </a>  <font color="#B22222">/* report numeric factorization of A' when Control[PRL] &gt; 3 */</font>
<a name="line131">131: </a>  (void) umfpack_di_report_numeric (lu-&gt;Numeric, lu-&gt;Control);

<a name="line133">133: </a>  <font color="#4169E1">if</font> (lu-&gt;flg == DIFFERENT_NONZERO_PATTERN){  <font color="#B22222">/* first numeric factorization */</font>
<a name="line134">134: </a>    <font color="#B22222">/* allocate working space to be used by Solve */</font>
<a name="line135">135: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(m * <font color="#4169E1">sizeof</font>(int), &amp;lu-&gt;Wi);
<a name="line136">136: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(5*m * <font color="#4169E1">sizeof</font>(double), &amp;lu-&gt;W);
<a name="line137">137: </a>  }
<a name="line138">138: </a>  lu-&gt;flg = SAME_NONZERO_PATTERN;
<a name="line139">139: </a>  lu-&gt;CleanUpUMFPACK = <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line140">140: </a>  <font color="#4169E1">return</font>(0);
<a name="line141">141: </a>}

<a name="line143">143: </a><font color="#B22222">/*</font>
<a name="line144">144: </a><font color="#B22222">   Note the r permutation is ignored</font>
<a name="line145">145: </a><font color="#B22222">*/</font>
<a name="line148">148: </a><strong><font color="#4169E1"><a name="MatLUFactorSymbolic_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLUFactorSymbolic_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A> r,<A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A> c,<A href="../../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *F)</font></strong>
<a name="line149">149: </a>{
<a name="line150">150: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>         B;
<a name="line151">151: </a>  Mat_SeqAIJ  *mat=(Mat_SeqAIJ*)A-&gt;data;
<a name="line152">152: </a>  Mat_UMFPACK *lu;
<a name="line154">154: </a>  int          m=A-&gt;rmap.n,n=A-&gt;cmap.n,*ai=mat-&gt;i,*aj=mat-&gt;j,status,*ra,idx;
<a name="line155">155: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *av=mat-&gt;a;
<a name="line156">156: </a>  const char  *strategy[]={<font color="#666666">"AUTO"</font>,<font color="#666666">"UNSYMMETRIC"</font>,<font color="#666666">"SYMMETRIC"</font>,<font color="#666666">"2BY2"</font>},
<a name="line157">157: </a>              *scale[]={<font color="#666666">"NONE"</font>,<font color="#666666">"SUM"</font>,<font color="#666666">"MAX"</font>};
<a name="line158">158: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>  flg;
<a name="line159">159: </a>
<a name="line161">161: </a>  <font color="#B22222">/* Create the factorization matrix F */</font>
<a name="line162">162: </a>  <A href="../../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(A-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;B);
<a name="line163">163: </a>  <A href="../../../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(B,<A href="../../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,m,n);
<a name="line164">164: </a>  <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(B,A-&gt;type_name);
<a name="line165">165: </a>  <A href="../../../../../../docs/manualpages/Mat/MatSeqAIJSetPreallocation.html#MatSeqAIJSetPreallocation">MatSeqAIJSetPreallocation</A>(B,0,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line166">166: </a>
<a name="line167">167: </a>  B-&gt;ops-&gt;lufactornumeric = MatLUFactorNumeric_UMFPACK;
<a name="line168">168: </a>  B-&gt;ops-&gt;solve           = MatSolve_UMFPACK;
<a name="line169">169: </a>  B-&gt;factor               = FACTOR_LU;
<a name="line170">170: </a>  B-&gt;assembled            = <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;  <font color="#B22222">/* required by -ksp_view */</font>

<a name="line172">172: </a>  lu = (Mat_UMFPACK*)(B-&gt;spptr);
<a name="line173">173: </a>
<a name="line174">174: </a>  <font color="#B22222">/* initializations */</font>
<a name="line175">175: </a>  <font color="#B22222">/* ------------------------------------------------*/</font>
<a name="line176">176: </a>  <font color="#B22222">/* get the default control parameters */</font>
<a name="line177">177: </a>  umfpack_di_defaults (lu-&gt;Control);
<a name="line178">178: </a>  lu-&gt;perm_c = <A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>;  <font color="#B22222">/* use defaul UMFPACK col permutation */</font>
<a name="line179">179: </a>  lu-&gt;Control[UMFPACK_IRSTEP] = 0; <font color="#B22222">/* max num of iterative refinement steps to attempt */</font>

<a name="line181">181: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsBegin.html#PetscOptionsBegin">PetscOptionsBegin</A>(A-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,A-&gt;prefix,<font color="#666666">"UMFPACK Options"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>"</font>);
<a name="line182">182: </a>  <font color="#B22222">/* Control parameters used by reporting routiones */</font>
<a name="line183">183: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_prl"</font>,<font color="#666666">"Control[UMFPACK_PRL]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_PRL],&amp;lu-&gt;Control[UMFPACK_PRL],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line185">185: </a>  <font color="#B22222">/* Control parameters for symbolic factorization */</font>
<a name="line186">186: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsEList.html#PetscOptionsEList">PetscOptionsEList</A>(<font color="#666666">"-mat_umfpack_strategy"</font>,<font color="#666666">"ordering and pivoting strategy"</font>,<font color="#666666">"None"</font>,strategy,4,strategy[0],&amp;idx,&amp;flg);
<a name="line187">187: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line188">188: </a>    <font color="#4169E1">switch</font> (idx){
<a name="line189">189: </a>    <font color="#4169E1">case</font> 0: lu-&gt;Control[UMFPACK_STRATEGY] = UMFPACK_STRATEGY_AUTO; <font color="#4169E1">break</font>;
<a name="line190">190: </a>    <font color="#4169E1">case</font> 1: lu-&gt;Control[UMFPACK_STRATEGY] = UMFPACK_STRATEGY_UNSYMMETRIC; <font color="#4169E1">break</font>;
<a name="line191">191: </a>    <font color="#4169E1">case</font> 2: lu-&gt;Control[UMFPACK_STRATEGY] = UMFPACK_STRATEGY_SYMMETRIC; <font color="#4169E1">break</font>;
<a name="line192">192: </a>    <font color="#4169E1">case</font> 3: lu-&gt;Control[UMFPACK_STRATEGY] = UMFPACK_STRATEGY_2BY2; <font color="#4169E1">break</font>;
<a name="line193">193: </a>    }
<a name="line194">194: </a>  }
<a name="line195">195: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_dense_col"</font>,<font color="#666666">"Control[UMFPACK_DENSE_COL]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_DENSE_COL],&amp;lu-&gt;Control[UMFPACK_DENSE_COL],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line196">196: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_dense_row"</font>,<font color="#666666">"Control[UMFPACK_DENSE_ROW]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_DENSE_ROW],&amp;lu-&gt;Control[UMFPACK_DENSE_ROW],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line197">197: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_amd_dense"</font>,<font color="#666666">"Control[UMFPACK_AMD_DENSE]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_AMD_DENSE],&amp;lu-&gt;Control[UMFPACK_AMD_DENSE],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line198">198: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_block_size"</font>,<font color="#666666">"Control[UMFPACK_BLOCK_SIZE]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_BLOCK_SIZE],&amp;lu-&gt;Control[UMFPACK_BLOCK_SIZE],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line199">199: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_2by2_tolerance"</font>,<font color="#666666">"Control[UMFPACK_2BY2_TOLERANCE]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_2BY2_TOLERANCE],&amp;lu-&gt;Control[UMFPACK_2BY2_TOLERANCE],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line200">200: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_fixq"</font>,<font color="#666666">"Control[UMFPACK_FIXQ]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_FIXQ],&amp;lu-&gt;Control[UMFPACK_FIXQ],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line201">201: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_aggressive"</font>,<font color="#666666">"Control[UMFPACK_AGGRESSIVE]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_AGGRESSIVE],&amp;lu-&gt;Control[UMFPACK_AGGRESSIVE],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line203">203: </a>  <font color="#B22222">/* Control parameters used by numeric factorization */</font>
<a name="line204">204: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_pivot_tolerance"</font>,<font color="#666666">"Control[UMFPACK_PIVOT_TOLERANCE]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_PIVOT_TOLERANCE],&amp;lu-&gt;Control[UMFPACK_PIVOT_TOLERANCE],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line205">205: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_sym_pivot_tolerance"</font>,<font color="#666666">"Control[UMFPACK_SYM_PIVOT_TOLERANCE]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_SYM_PIVOT_TOLERANCE],&amp;lu-&gt;Control[UMFPACK_SYM_PIVOT_TOLERANCE],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line206">206: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsEList.html#PetscOptionsEList">PetscOptionsEList</A>(<font color="#666666">"-mat_umfpack_scale"</font>,<font color="#666666">"Control[UMFPACK_SCALE]"</font>,<font color="#666666">"None"</font>,scale,3,scale[0],&amp;idx,&amp;flg);
<a name="line207">207: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line208">208: </a>    <font color="#4169E1">switch</font> (idx){
<a name="line209">209: </a>    <font color="#4169E1">case</font> 0: lu-&gt;Control[UMFPACK_SCALE] = UMFPACK_SCALE_NONE; <font color="#4169E1">break</font>;
<a name="line210">210: </a>    <font color="#4169E1">case</font> 1: lu-&gt;Control[UMFPACK_SCALE] = UMFPACK_SCALE_SUM; <font color="#4169E1">break</font>;
<a name="line211">211: </a>    <font color="#4169E1">case</font> 2: lu-&gt;Control[UMFPACK_SCALE] = UMFPACK_SCALE_MAX; <font color="#4169E1">break</font>;
<a name="line212">212: </a>    }
<a name="line213">213: </a>  }
<a name="line214">214: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_alloc_init"</font>,<font color="#666666">"Control[UMFPACK_ALLOC_INIT]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_ALLOC_INIT],&amp;lu-&gt;Control[UMFPACK_ALLOC_INIT],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line215">215: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_front_alloc_init"</font>,<font color="#666666">"Control[UMFPACK_FRONT_ALLOC_INIT]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_FRONT_ALLOC_INIT],&amp;lu-&gt;Control[UMFPACK_ALLOC_INIT],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line216">216: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_droptol"</font>,<font color="#666666">"Control[UMFPACK_DROPTOL]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_DROPTOL],&amp;lu-&gt;Control[UMFPACK_DROPTOL],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line218">218: </a>  <font color="#B22222">/* Control parameters used by solve */</font>
<a name="line219">219: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-mat_umfpack_irstep"</font>,<font color="#666666">"Control[UMFPACK_IRSTEP]"</font>,<font color="#666666">"None"</font>,lu-&gt;Control[UMFPACK_IRSTEP],&amp;lu-&gt;Control[UMFPACK_IRSTEP],<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line220">220: </a>
<a name="line221">221: </a>  <font color="#B22222">/* use Petsc mat ordering (note: <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> is for the transpose, and PETSc r = Umfpack perm_c) */</font>
<a name="line222">222: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-pc_factor_mat_ordering_type"</font>,&amp;lu-&gt;PetscMatOdering);
<a name="line223">223: </a>  <font color="#4169E1">if</font> (lu-&gt;PetscMatOdering) {
<a name="line224">224: </a>    <A href="../../../../../../docs/manualpages/IS/ISGetIndices.html#ISGetIndices">ISGetIndices</A>(r,&amp;ra);
<a name="line225">225: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(A-&gt;rmap.n*<font color="#4169E1">sizeof</font>(int),&amp;lu-&gt;perm_c);
<a name="line226">226: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(lu-&gt;perm_c,ra,A-&gt;rmap.n*<font color="#4169E1">sizeof</font>(int));
<a name="line227">227: </a>    <A href="../../../../../../docs/manualpages/IS/ISRestoreIndices.html#ISRestoreIndices">ISRestoreIndices</A>(r,&amp;ra);
<a name="line228">228: </a>  }
<a name="line229">229: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsEnd.html#PetscOptionsEnd">PetscOptionsEnd</A>();

<a name="line231">231: </a>  <font color="#B22222">/* print the control parameters */</font>
<a name="line232">232: </a>  <font color="#4169E1">if</font>( lu-&gt;Control[UMFPACK_PRL] &gt; 1 ) umfpack_di_report_control (lu-&gt;Control);

<a name="line234">234: </a>  <font color="#B22222">/* symbolic factorization of A' */</font>
<a name="line235">235: </a>  <font color="#B22222">/* ---------------------------------------------------------------------- */</font>
<a name="line236">236: </a>  <font color="#4169E1">if</font> (lu-&gt;PetscMatOdering) { <font color="#B22222">/* use Petsc row ordering */</font>
<a name="line237">237: </a>    status = umfpack_di_qsymbolic(n,m,ai,aj,av,lu-&gt;perm_c,&amp;lu-&gt;Symbolic,lu-&gt;Control,lu-&gt;Info);
<a name="line238">238: </a>  } <font color="#4169E1">else</font> { <font color="#B22222">/* use Umfpack col ordering */</font>
<a name="line239">239: </a>    status = umfpack_di_symbolic(n,m,ai,aj,av,&amp;lu-&gt;Symbolic,lu-&gt;Control,lu-&gt;Info);
<a name="line240">240: </a>  }
<a name="line241">241: </a>  <font color="#4169E1">if</font> (status &lt; 0){
<a name="line242">242: </a>    umfpack_di_report_info(lu-&gt;Control, lu-&gt;Info);
<a name="line243">243: </a>    umfpack_di_report_status(lu-&gt;Control, status);
<a name="line244">244: </a>    <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_LIB,<font color="#666666">"umfpack_di_symbolic failed"</font>);
<a name="line245">245: </a>  }
<a name="line246">246: </a>  <font color="#B22222">/* report sumbolic factorization of A' when Control[PRL] &gt; 3 */</font>
<a name="line247">247: </a>  (void) umfpack_di_report_symbolic(lu-&gt;Symbolic, lu-&gt;Control);

<a name="line249">249: </a>  lu-&gt;flg = DIFFERENT_NONZERO_PATTERN;
<a name="line250">250: </a>  lu-&gt;ai  = ai;
<a name="line251">251: </a>  lu-&gt;aj  = aj;
<a name="line252">252: </a>  lu-&gt;av  = av;
<a name="line253">253: </a>  lu-&gt;CleanUpUMFPACK = <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line254">254: </a>  *F = B;
<a name="line255">255: </a>  <font color="#4169E1">return</font>(0);
<a name="line256">256: </a>}

<a name="line260">260: </a><strong><font color="#4169E1"><a name="MatAssemblyEnd_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatAssemblyEnd_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Mat/MatAssemblyType.html#MatAssemblyType">MatAssemblyType</A> mode)</font></strong>
<a name="line261">261: </a>{
<a name="line263">263: </a>  Mat_UMFPACK *lu=(Mat_UMFPACK*)(A-&gt;spptr);

<a name="line266">266: </a>  (*lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>)(A,mode);
<a name="line267">267: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatLUFactorSymbolic.html#MatLUFactorSymbolic">MatLUFactorSymbolic</A>  = A-&gt;ops-&gt;lufactorsymbolic;
<a name="line268">268: </a>  A-&gt;ops-&gt;lufactorsymbolic = MatLUFactorSymbolic_UMFPACK;
<a name="line269">269: </a>  <font color="#4169E1">return</font>(0);
<a name="line270">270: </a>}

<a name="line272">272: </a><font color="#B22222">/* used by -ksp_view */</font>
<a name="line275">275: </a><strong><font color="#4169E1"><a name="MatFactorInfo_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatFactorInfo_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line276">276: </a>{
<a name="line277">277: </a>  Mat_UMFPACK *lu= (Mat_UMFPACK*)A-&gt;spptr;

<a name="line281">281: </a>  <font color="#B22222">/* check if matrix is UMFPACK type */</font>
<a name="line282">282: </a>  <font color="#4169E1">if</font> (A-&gt;ops-&gt;solve != MatSolve_UMFPACK) <font color="#4169E1">return</font>(0);

<a name="line284">284: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"UMFPACK run parameters:\n"</font>);
<a name="line285">285: </a>  <font color="#B22222">/* Control parameters used by reporting routiones */</font>
<a name="line286">286: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_PRL]: %g\n"</font>,lu-&gt;Control[UMFPACK_PRL]);

<a name="line288">288: </a>  <font color="#B22222">/* Control parameters used by symbolic factorization */</font>
<a name="line289">289: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_STRATEGY]: %g\n"</font>,lu-&gt;Control[UMFPACK_STRATEGY]);
<a name="line290">290: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_DENSE_COL]: %g\n"</font>,lu-&gt;Control[UMFPACK_DENSE_COL]);
<a name="line291">291: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_DENSE_ROW]: %g\n"</font>,lu-&gt;Control[UMFPACK_DENSE_ROW]);
<a name="line292">292: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_AMD_DENSE]: %g\n"</font>,lu-&gt;Control[UMFPACK_AMD_DENSE]);
<a name="line293">293: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_BLOCK_SIZE]: %g\n"</font>,lu-&gt;Control[UMFPACK_BLOCK_SIZE]);
<a name="line294">294: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_2BY2_TOLERANCE]: %g\n"</font>,lu-&gt;Control[UMFPACK_2BY2_TOLERANCE]);
<a name="line295">295: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_FIXQ]: %g\n"</font>,lu-&gt;Control[UMFPACK_FIXQ]);
<a name="line296">296: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_AGGRESSIVE]: %g\n"</font>,lu-&gt;Control[UMFPACK_AGGRESSIVE]);

<a name="line298">298: </a>  <font color="#B22222">/* Control parameters used by numeric factorization */</font>
<a name="line299">299: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_PIVOT_TOLERANCE]: %g\n"</font>,lu-&gt;Control[UMFPACK_PIVOT_TOLERANCE]);
<a name="line300">300: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_SYM_PIVOT_TOLERANCE]: %g\n"</font>,lu-&gt;Control[UMFPACK_SYM_PIVOT_TOLERANCE]);
<a name="line301">301: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_SCALE]: %g\n"</font>,lu-&gt;Control[UMFPACK_SCALE]);
<a name="line302">302: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_ALLOC_INIT]: %g\n"</font>,lu-&gt;Control[UMFPACK_ALLOC_INIT]);
<a name="line303">303: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_DROPTOL]: %g\n"</font>,lu-&gt;Control[UMFPACK_DROPTOL]);

<a name="line305">305: </a>  <font color="#B22222">/* Control parameters used by solve */</font>
<a name="line306">306: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Control[UMFPACK_IRSTEP]: %g\n"</font>,lu-&gt;Control[UMFPACK_IRSTEP]);

<a name="line308">308: </a>  <font color="#B22222">/* mat ordering */</font>
<a name="line309">309: </a>  <font color="#4169E1">if</font>(!lu-&gt;PetscMatOdering) <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  UMFPACK default matrix ordering is used (not the PETSc matrix ordering) \n"</font>);

<a name="line311">311: </a>  <font color="#4169E1">return</font>(0);
<a name="line312">312: </a>}

<a name="line316">316: </a><strong><font color="#4169E1"><a name="MatView_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatView_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line317">317: </a>{
<a name="line319">319: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        iascii;
<a name="line320">320: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerFormat.html#PetscViewerFormat">PetscViewerFormat</A> format;
<a name="line321">321: </a>  Mat_UMFPACK       *lu=(Mat_UMFPACK*)(A-&gt;spptr);

<a name="line324">324: </a>  (*lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>)(A,viewer);

<a name="line326">326: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_ASCII,&amp;iascii);
<a name="line327">327: </a>  <font color="#4169E1">if</font> (iascii) {
<a name="line328">328: </a>    PetscViewerGetFormat(viewer,&amp;format);
<a name="line329">329: </a>    <font color="#4169E1">if</font> (format == PETSC_VIEWER_ASCII_INFO) {
<a name="line330">330: </a>      MatFactorInfo_UMFPACK(A,viewer);
<a name="line331">331: </a>    }
<a name="line332">332: </a>  }
<a name="line333">333: </a>  <font color="#4169E1">return</font>(0);
<a name="line334">334: </a>}

<a name="line339">339: </a><strong><font color="#4169E1"><a name="MatConvert_SeqAIJ_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_SeqAIJ_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A> type,<A href="../../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A> reuse,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *newmat)</font></strong>
<a name="line340">340: </a>{
<a name="line342">342: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            B=*newmat;
<a name="line343">343: </a>  Mat_UMFPACK    *lu;

<a name="line346">346: </a>  <font color="#4169E1">if</font> (reuse == MAT_INITIAL_MATRIX) {
<a name="line347">347: </a>    <A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>(A,MAT_COPY_VALUES,&amp;B);
<a name="line348">348: </a>  }

<a name="line350">350: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(Mat_UMFPACK,&amp;lu);
<a name="line351">351: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>         = A-&gt;ops-&gt;duplicate;
<a name="line352">352: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>              = A-&gt;ops-&gt;view;
<a name="line353">353: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>       = A-&gt;ops-&gt;assemblyend;
<a name="line354">354: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatLUFactorSymbolic.html#MatLUFactorSymbolic">MatLUFactorSymbolic</A>  = A-&gt;ops-&gt;lufactorsymbolic;
<a name="line355">355: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>           = A-&gt;ops-&gt;destroy;
<a name="line356">356: </a>  lu-&gt;CleanUpUMFPACK       = <A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;

<a name="line358">358: </a>  B-&gt;spptr                 = (void*)lu;
<a name="line359">359: </a>  B-&gt;ops-&gt;duplicate        = MatDuplicate_UMFPACK;
<a name="line360">360: </a>  B-&gt;ops-&gt;view             = MatView_UMFPACK;
<a name="line361">361: </a>  B-&gt;ops-&gt;assemblyend      = MatAssemblyEnd_UMFPACK;
<a name="line362">362: </a>  B-&gt;ops-&gt;lufactorsymbolic = MatLUFactorSymbolic_UMFPACK;
<a name="line363">363: </a>  B-&gt;ops-&gt;destroy          = MatDestroy_UMFPACK;

<a name="line365">365: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_seqaij_umfpack_C"</font>,
<a name="line366">366: </a>                                           <font color="#666666">"MatConvert_SeqAIJ_UMFPACK"</font>,MatConvert_SeqAIJ_UMFPACK);
<a name="line367">367: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_umfpack_seqaij_C"</font>,
<a name="line368">368: </a>                                           <font color="#666666">"MatConvert_UMFPACK_SeqAIJ"</font>,MatConvert_UMFPACK_SeqAIJ);
<a name="line369">369: </a>  <A href="../../../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(0,<font color="#666666">"Using UMFPACK for SeqAIJ LU factorization and solves.\n"</font>);
<a name="line370">370: </a>  PetscObjectChangeTypeName((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<A href="../../../../../../docs/manualpages/Mat/MATUMFPACK.html#MATUMFPACK">MATUMFPACK</A>);
<a name="line371">371: </a>  *newmat = B;
<a name="line372">372: </a>  <font color="#4169E1">return</font>(0);
<a name="line373">373: </a>}

<a name="line378">378: </a><strong><font color="#4169E1"><a name="MatDuplicate_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDuplicate_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A, <A href="../../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A> op, <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *M)</font></strong>
<a name="line379">379: </a>{
<a name="line381">381: </a>  Mat_UMFPACK *lu=(Mat_UMFPACK*)A-&gt;spptr;

<a name="line384">384: </a>  (*lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>)(A,op,M);
<a name="line385">385: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>((*M)-&gt;spptr,lu,<font color="#4169E1">sizeof</font>(Mat_UMFPACK));
<a name="line386">386: </a>  <font color="#4169E1">return</font>(0);
<a name="line387">387: </a>}

<a name="line389">389: </a><font color="#B22222">/*MC</font>
<a name="line390">390: </a><font color="#B22222">  <A href="../../../../../../docs/manualpages/Mat/MATUMFPACK.html#MATUMFPACK">MATUMFPACK</A> - <A href="../../../../../../docs/manualpages/Mat/MATUMFPACK.html#MATUMFPACK">MATUMFPACK</A> = "umfpack" - A matrix type providing direct solvers (LU) for sequential matrices </font>
<a name="line391">391: </a><font color="#B22222">  via the external package UMFPACK.</font>

<a name="line393">393: </a><font color="#B22222">  If UMFPACK is installed (see the manual for</font>
<a name="line394">394: </a><font color="#B22222">  instructions on how to declare the existence of external packages),</font>
<a name="line395">395: </a><font color="#B22222">  a matrix type can be constructed which invokes UMFPACK solvers.</font>
<a name="line396">396: </a><font color="#B22222">  After calling <A href="../../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(...,A), simply call <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(A,UMFPACK).</font>
<a name="line397">397: </a><font color="#B22222">  This matrix type is only supported for double precision real.</font>

<a name="line399">399: </a><font color="#B22222">  This matrix inherits from <A href="../../../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A>.  As a result, <A href="../../../../../../docs/manualpages/Mat/MatSeqAIJSetPreallocation.html#MatSeqAIJSetPreallocation">MatSeqAIJSetPreallocation</A> is </font>
<a name="line400">400: </a><font color="#B22222">  supported for this matrix type.  One can also call <A href="../../../../../../docs/manualpages/Mat/MatConvert.html#MatConvert">MatConvert</A> for an inplace conversion to or from </font>
<a name="line401">401: </a><font color="#B22222">  the <A href="../../../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A> type without data copy.</font>

<a name="line403">403: </a><font color="#B22222">  Consult UMFPACK documentation for more information about the Control parameters</font>
<a name="line404">404: </a><font color="#B22222">  which correspond to the options database keys below.</font>

<a name="line406">406: </a><font color="#B22222">  Options Database Keys:</font>
<a name="line407">407: </a><font color="#B22222">+ -mat_type umfpack - sets the matrix type to "umfpack" during a call to <A href="../../../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>()</font>
<a name="line408">408: </a><font color="#B22222">. -mat_umfpack_prl - UMFPACK print level: Control[UMFPACK_PRL]</font>
<a name="line409">409: </a><font color="#B22222">. -mat_umfpack_dense_col &lt;alpha_c&gt; - UMFPACK dense column threshold: Control[UMFPACK_DENSE_COL]</font>
<a name="line410">410: </a><font color="#B22222">. -mat_umfpack_block_size &lt;bs&gt; - UMFPACK block <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> for BLAS-Level 3 calls: Control[UMFPACK_BLOCK_SIZE]</font>
<a name="line411">411: </a><font color="#B22222">. -mat_umfpack_pivot_tolerance &lt;delta&gt; - UMFPACK partial pivot tolerance: Control[UMFPACK_PIVOT_TOLERANCE]</font>
<a name="line412">412: </a><font color="#B22222">. -mat_umfpack_alloc_init &lt;delta&gt; - UMFPACK factorized matrix allocation modifier: Control[UMFPACK_ALLOC_INIT]</font>
<a name="line413">413: </a><font color="#B22222">- -mat_umfpack_irstep &lt;maxit&gt; - UMFPACK maximum number of iterative refinement steps: Control[UMFPACK_IRSTEP]</font>

<a name="line415">415: </a><font color="#B22222">   Level: beginner</font>

<a name="line417">417: </a><font color="#B22222">.seealso: <A href="../../../../../../docs/manualpages/PC/PCLU.html#PCLU">PCLU</A></font>
<a name="line418">418: </a><font color="#B22222">M*/</font>

<a name="line423">423: </a><strong><font color="#4169E1"><a name="MatCreate_UMFPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatCreate_UMFPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A)</font></strong>
<a name="line424">424: </a>{

<a name="line428">428: </a>  <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(A,<A href="../../../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A>);
<a name="line429">429: </a>  MatConvert_SeqAIJ_UMFPACK(A,<A href="../../../../../../docs/manualpages/Mat/MATUMFPACK.html#MATUMFPACK">MATUMFPACK</A>,MAT_REUSE_MATRIX,&amp;A);
<a name="line430">430: </a>  <font color="#4169E1">return</font>(0);
<a name="line431">431: </a>}
</pre>
</body>

</html>
